package me.parsell.wireddust;

import me.shedaniel.autoconfig.ConfigData;
import me.shedaniel.autoconfig.annotation.Config;

@Config(name = "GlowstoneWire")
public class WiredDustConfig implements ConfigData{
    public boolean useVanillaItems = true;

    public boolean addSugarWire = true;
    public boolean addGlowstoneWire = true;

    public boolean addBlazePowderWire = true;
    public boolean doBlazePowderDamage = true;

    public boolean addGunpowderWire = true;
    public boolean gunpowderWireIgnitesExtremelyFlammableBlocks = true;
    public boolean gunpowderWireIgnitesFlammableBlocks = false;
    public boolean gunpowderWireIgnitesTNT = true;

    //TODO Consider gamerules for additional functionality instead of mod config
}
