package me.parsell.wireddust.common;

import java.util.Random;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.block.Block;
import net.minecraft.block.BlockState;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Items;
import net.minecraft.particle.ParticleTypes;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.state.StateManager;
import net.minecraft.state.property.BooleanProperty;
import net.minecraft.state.property.Properties;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Box;
import net.minecraft.util.math.Direction.Axis;
import net.minecraft.world.World;

// TODO: All the magic to make this work the way i want
public class WDGunpowderWireBlock extends WDWireBlock{
    public static final BooleanProperty LIT;

    public WDGunpowderWireBlock(Settings settings) {
        super(settings);
        this.setDefaultState((BlockState)((BlockState)((BlockState)((BlockState)((BlockState)((BlockState)this.stateManager.getDefaultState()).with(WIRE_CONNECTION_NORTH, WDWireConnection.NONE)).with(WIRE_CONNECTION_EAST, WDWireConnection.NONE)).with(WIRE_CONNECTION_SOUTH, WDWireConnection.NONE)).with(WIRE_CONNECTION_WEST, WDWireConnection.NONE)).with(LIT, false));
    }

    @Override
	protected void appendProperties(StateManager.Builder<Block, BlockState> builder) {
        super.appendProperties(builder.add(LIT));
	}

    private boolean hasUpConnection(BlockState state){
        return ((WDWireConnection)state.get(WIRE_CONNECTION_NORTH)).isConnectedUp() || 
                ((WDWireConnection)state.get(WIRE_CONNECTION_SOUTH)).isConnectedUp() ||
                ((WDWireConnection)state.get(WIRE_CONNECTION_EAST)).isConnectedUp() ||
                ((WDWireConnection)state.get(WIRE_CONNECTION_WEST)).isConnectedUp();
    }

    static boolean pp = true;

    // TODO: Supprt UP state
    @Environment(EnvType.CLIENT)
    public void randomDisplayTick(BlockState state, World world, BlockPos pos, Random random) {
        if (state.get(LIT)){
            // get random double, within bounds x/y_min and x/y_max
            double x_min = super.STATE_TO_VOXELSHAPE.get(state).getMin(Axis.X);
            double z_min = super.STATE_TO_VOXELSHAPE.get(state).getMin(Axis.Z);
            double x_max = super.STATE_TO_VOXELSHAPE.get(state).getMax(Axis.X);
            double z_max = super.STATE_TO_VOXELSHAPE.get(state).getMax(Axis.Z);
                
            double x_rand = x_min + (x_max - x_min) * random.nextDouble();
            double z_rand = z_min + (z_max - z_min) * random.nextDouble();

            double y_rand = 0.1d;

            if (hasUpConnection(state)){
                if (z_rand < 0.1d && state.get(WIRE_CONNECTION_NORTH).isConnectedUp() ||
                    z_rand > 0.9d && state.get(WIRE_CONNECTION_SOUTH).isConnectedUp() ||
                    x_rand < 0.1d && state.get(WIRE_CONNECTION_WEST).isConnectedUp() ||
                    x_rand > 0.9d && state.get(WIRE_CONNECTION_EAST).isConnectedUp()) {
                        y_rand = 0.1D + (0.9D - 0.1D) * random.nextDouble(); 
                }
            } 

            System.out.printf("X: %1.2f | Y: %1.2f | Z: %1.2f\n", x_rand, y_rand, z_rand);

            //NEW
            /*
            double rand_x, rand_y, rand_z;
            boolean validParticle = false;

            if (pp) {
                pp = false;
                System.out.println(super.STATE_TO_VOXELSHAPE.get(state).getBoundingBoxes().size());
            }

            do{
                rand_x = random.nextDouble();
                rand_y = random.nextDouble();
                rand_z = random.nextDouble();

                for (Box b : super.STATE_TO_VOXELSHAPE.get(state).getBoundingBoxes()){
                    if (b.contains(rand_x, rand_y, rand_z))
                        validParticle = true;
                        break;
                }   
            }while (!validParticle); */

           world.addParticle(ParticleTypes.FLAME, pos.getX() + x_rand, pos.getY() + y_rand, pos.getZ() + z_rand, 0.0, 0.0, 0.0);
           super.randomDisplayTick(state, world, pos, random);
        }
    }

    // TODO: TEST KILLING MINECRAFT WITH REDSTONE & FILL COMMANDS
    @Override
    public ActionResult onUse(BlockState state, World world, BlockPos pos, PlayerEntity player, Hand hand, BlockHitResult hit){
        if(world.isClient)
            return ActionResult.SUCCESS;
        if(player.abilities.allowModifyWorld){
            if(!state.get(LIT) && player.getStackInHand(hand).getItem().equals(Items.FLINT_AND_STEEL)){
                player.getStackInHand(hand).damage(1, world.getRandom(), (ServerPlayerEntity)player);
                world.setBlockState(pos, state.with(LIT, true));
                return ActionResult.SUCCESS;
            }
        }

        super.onUse(state, world, pos, player, hand, hit);
        return ActionResult.PASS;
    }
    
    static {
        LIT = Properties.LIT;
    }
}
